/*
	Program ukazujici zakladni aplikaci pro MS-Windows.
*/

#include <windows.h>
#include "generic.h"

const char className[]="GenericClass";

HINSTANCE ghInstance;

LRESULT CALLBACK AboutDialog(HWND dialog, 
	                         UINT msg, 
							 WPARAM wParam,
							 LPARAM lParam)
{
	switch (msg)
	{
		case WM_INITDIALOG:
	    	return TRUE;
		case WM_COMMAND:
			if (LOWORD(wParam)==IDOK || LOWORD(wParam)==IDCANCEL)
				{
					EndDialog(dialog,TRUE);
					return TRUE;
				}
			break;
	}

	return FALSE;
}

LRESULT CALLBACK MainWindowProc(HWND window,
	                            UINT msg,
								WPARAM wParam,
								LPARAM lParam)
{
	switch (msg)
	{
		case WM_COMMAND:
			if (LOWORD(wParam) == IDM_ABOUT)
				DialogBox(ghInstance, "AboutBox", window, (DLGPROC)AboutDialog);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(window,msg,wParam,lParam);
	};
	
	return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
	                 HINSTANCE hPrevInstance,
				     LPSTR lpszCmdLine,
				     int nCmdShow)
{
	WNDCLASS windowClass;
	MSG msg;
	HWND window;

	ghInstance=hInstance;

	windowClass.style=0;
	windowClass.lpfnWndProc=MainWindowProc;
	windowClass.cbClsExtra=0;
	windowClass.cbWndExtra=0;
	windowClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	windowClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	windowClass.hbrBackground=(HBRUSH) GetStockObject(WHITE_BRUSH);
	windowClass.lpszMenuName="GenericMenu";
	windowClass.lpszClassName=className;
	windowClass.hInstance=hInstance;

	if (!RegisterClass(&windowClass))
		return 255;

	window=CreateWindow(className,
		                "C++ Generic",
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						HWND_DESKTOP,
						NULL,
						hInstance,
						NULL);

	ShowWindow(window,nCmdShow);
	UpdateWindow(window);

	while (GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}